/* gcc_cpp */
#include <fstream>
#include <string>
#include <iomanip>

using namespace std;

const char *infile="evo.dat";
const char *outfile="evo.sol";

const int base=10000;
const int baseLen=4;
const int numL=35;
typedef short dig_t;
typedef long  rem_t;

struct LongNum {
     dig_t d[(numL+baseLen-1)/baseLen];
     int n;
     LongNum():n(0) {}
     LongNum(string s) {
          rem_t rem; 
          int i,j,sn=s.size();
          for(n=0,i=sn-1;i>=0;i-=baseLen) {
               for(j=i-baseLen+1,rem=0;j<=i;j++) 
                    if(j>=0)rem=10*rem+s[j]-'0';
               d[n++]=rem;
          }
          while(n>0&&d[n-1]==0)n--;
     }
     LongNum &operator/=(int div) {
          rem_t rem;
          for(int i=n-1,rem=0;i>=0;i--) {
               rem=base*rem+d[i];
               d[i]=rem/div;
               rem%=div;
          }
          while(n>0&&d[n-1]==0)n--;
          return *this;
     }
};
ostream &operator<<(ostream &os,const LongNum &ln) {
     if(!ln.n)return os<<"0";
     else {
          os<<setw(0)<<ln.d[ln.n-1]<<setfill('0');
          for(int i=ln.n-2;i>=0;i--)os<<setw(baseLen)<<ln.d[i];
          return os<<setw(0);
     }
}

inline int numcmp(const LongNum &a,const LongNum &b) {
     int i;
     if(a.n<b.n)return -1;
     else if(a.n>b.n)return 1;
     for(i=a.n-1;i>=0&&a.d[i]==b.d[i];i--);
     if(i<0)return 0;
     else if(a.d[i]>b.d[i])return 1;
     else return -1;
}

int main() {
     int n;
     string as,bs;
     LongNum a,b;
     int c;
     ifstream ifs(infile);
     ofstream ofs(outfile);
    
     ifs>>n>>as>>bs;
     a=as;b=bs;
     while(c=numcmp(a,b)) {
          if(c>0)a/=2;
          else b/=2;
     }
     ofs<<a<<endl;
     
     return 0;
}
