#include <cstdio>
#include <fstream>
#include <algorithm>

using namespace std;

const char *infile="ridge.dat";
const char *outfile="ridge.sol";

const int maxN=100000;

typedef long long LLong;

int h[maxN],h1[maxN];
int view[maxN];
int last[2*maxN+1];
int nu;

inline int GetLast(int from,int to) {
     int res=-1;
     for(from+=nu,to+=nu;from<=to;) {
          res=max(res,last[from]);
          res=max(res,last[to]);
          if(from&1)from=from/2+1;
          else from=from/2;
          if(to&1)to/=2;
          else to=to/2-1;
     }
     return res;
}

inline void Update(int where,int what) {
     for(where+=nu;where>=1;where/=2)
          last[where]=max(last[where],what);
}

int main() {
     int n,t,i;
     LLong res,cur;
     FILE *ifs=fopen(infile,"r");
     ofstream ofs(outfile);

     fscanf(ifs,"%d%d",&n,&t);
     for(i=0;i<n;i++)fscanf(ifs,"%d",&h[i]),h1[i]=h[i];
     
     sort(h1,h1+n);
     nu=unique(h1,h1+n)-h1;
     for(i=0;i<n;i++)
          h[i]=lower_bound(h1,h1+nu,h[i])-h1;
          
     for(i=0;i<2*nu;i++)last[i]=-1;
     for(i=0;i<n;i++) {
          view[i]=GetLast(h[i],nu-1);
          Update(h[i],i);
     }
     for(i=0;i<2*nu;i++)last[i]=-1;
     for(i=n-1;i>=0;i--) {
          view[i]=(n-1-GetLast(h[i],nu-1))-view[i]-2;
          Update(h[i],n-1-i);
     }
     for(i=0,res=-1,cur=0;i<n;i++) {
          cur+=view[i];
          if(i>=t)cur-=view[i-t];
          if(res<cur)res=cur;
     }
     ofs<<res<<endl;

     fclose(ifs);
     return 0;
}
